unit VM8095Progr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    Button11: TButton;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button8: TButton;
    Button9: TButton;
    Button2: TButton;
    Button7: TButton;
    GroupBox2: TGroupBox;
    Button10: TButton;
    Timer1: TTimer;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ReadVersion;
    procedure Button2Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MemoryImage: array[0..66000] of byte;
  ReadImage: array[0..66000] of byte;
  table: array[0..7] of integer;
  MaxAddress: integer;
  timed: boolean;
implementation

{$R *.DFM}

procedure ResetPIC; stdcall; external 'VM8095Programmer.dll';
procedure RunPIC; stdcall; external 'VM8095Programmer.dll';
procedure Erase; stdcall; external 'VM8095Programmer.dll';
function  Complete: integer; stdcall; external 'VM8095Programmer.dll';
procedure PreSend64(address: integer); stdcall; external 'VM8095Programmer.dll';
procedure Read64(address: integer; data: pointer); stdcall; external 'VM8095Programmer.dll';
procedure Tx64(data: pointer); stdcall; external 'VM8095Programmer.dll';
function  OpenDevices: integer; stdcall; external 'VM8095Programmer.dll';
procedure CloseDevices; stdcall; external 'VM8095Programmer.dll';
function  SendButtonCommand(command: integer): integer; stdcall; external 'VM8095Programmer.dll';
function  VersionFirmware: integer; stdcall; external 'VM8095Programmer.dll';
function  IsRunning: integer; stdcall; external 'VM8095Programmer.dll';
function  PlayMusic: integer; stdcall; external 'VM8095Programmer.dll';


procedure TForm1.Button1Click(Sender: TObject);
var Cards:integer;
begin
  memo1.clear;
  Button6.enabled:=false;
  Button7.enabled:=false;
  Button11.enabled:=false;

  Button3.enabled:=false;
  Button4.enabled:=false;
  Button5.enabled:=false;
  BitBtn1.enabled:=false;
  BitBtn2.enabled:=false;
  Button8.enabled:=false;
  Button9.enabled:=false;
  Button10.enabled:=false;

  Button12.enabled:=false;
  Button13.enabled:=false;
  Button14.enabled:=false;
  Button15.enabled:=false;
  Button16.enabled:=false;
  Button17.enabled:=false;
  Button18.enabled:=false;


  Cards:=OpenDevices;
  case Cards of
    0: memo1.lines.add('Card open error.');
    1: begin
            memo1.lines.add('VM8095 connected');
            ReadVersion;
            //memo1.lines.add(inttostr(IsRunning));
            if IsRunning=1 then
            begin
              memo1.lines.add('Load HEX file to update the firmware,');
              memo1.lines.add('or press ''Play'' to use the play controls.');
              Button2.enabled:=true;
              Button6.enabled:=true;
            end
            else
            begin
              memo1.lines.add('VM8095 is in play mode.');
              Button3.enabled:=true;
              Button4.enabled:=true;
              Button5.enabled:=true;
              Button7.enabled:=true;
              BitBtn1.enabled:=true;
              BitBtn2.enabled:=true;
              Button8.enabled:=true;
              Button9.enabled:=true;
              Button10.enabled:=true;
              Button12.enabled:=true;
              Button13.enabled:=true;
              Button14.enabled:=true;
              Button15.enabled:=true;
              Button16.enabled:=true;
              Button17.enabled:=true;
              Button18.enabled:=true;
            end;
        end;
    -1: memo1.lines.add('Card not found.');
  end;   
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseDevices;
end;

procedure TForm1.ReadVersion;
var ver:integer;
begin
  ver:=VersionFirmware;
  memo1.lines.add('Loader: v'+inttostr(ver shr 24)+'.'+inttostr($FF and (ver shr 16))
    +'.'+inttostr($FF and (ver shr 8)));
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  SendButtonCommand(1);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SendButtonCommand(2);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SendButtonCommand(3);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  SendButtonCommand(7);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  SendButtonCommand(6);
end;

procedure TForm1.Button6Click(Sender: TObject);
var HexFile: TextFile;
LineLength : string;
DataType : string;
AddressA : string;
DataLength, i, j : integer;
Address : integer;
Line, s, filename: string;
begin
  memo1.clear;
  MaxAddress:=0;
  for i:=0 to 66000 do
    MemoryImage[i]:=255;
  if Opendialog1.Execute then
  begin
    filename:=extractfilename(OpenDialog1.FileName);
    AssignFile(HexFile, OpenDialog1.FileName);
    {$I-}
    Reset(HexFile);
    {$I+}
    if IOResult=0 then
    begin
      while not Eof(HexFile) do
      begin
        readln(HexFile, Line);
        LineLength:=Copy(Line, 2, 2);
        AddressA:=Copy(Line, 4, 4);
        DataType:=Copy(Line, 8, 2);
        if DataType='00' then
        begin
          DataLength:=StrToInt('$'+LineLength);
          Address:=StrToInt('$'+AddressA);
          if Address+DataLength<$F800 then
          begin
            for i:=0 to DataLength-1 do
              MemoryImage[Address+i]:=StrToInt('$'+Copy(Line,10+i*2,2));
            MaxAddress:=Address+DataLength-1;
          end;
        end;
      end;
      closefile(HexFile);
      memo1.lines.add('HEX file loaded: '+filename);
      memo1.lines.add('Max. program address: '+inttohex(MaxAddress,4));
      memo1.lines.add('Press ''Program the Device'' to update the firmware.');
      Button11.enabled:=true;
       {
       for j:=0 to 10 do
       begin
         s:=inttohex($400+j*$10,4)+'  ';
         for i:=0 to 15 do
           s:=s+' '+inttohex(MemoryImage[i+$400+j*$10],2);
         memo1.lines.add(s);
       end;
         memo1.lines.add('- - -');
         s:=inttohex(MaxAddress,4)+'  ';
         for i:=0 to 15 do
           s:=s+' '+inttohex(MemoryImage[i+MaxAddress],2);
         memo1.lines.add(s);
        }
    end
    else
      memo1.lines.add('Failed to load the HEX file.');

  end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var tmp, i, j, address, erra: integer;
arr: array[0..63] of byte;
errs: string;
begin
  if MaxAddress>$400 then
  begin
    Button2.enabled:=false;
 //   Button7.enabled:=false;

    // LCD >
    SendButtonCommand(130);        // LCD "Erasing..."
    repeat
      tmp:=Complete;
    until tmp=1;
    // <LCD

    Erase;

    memo1.lines.add('Erasing...');
    repeat
      tmp:=Complete;
    until tmp=1;
    memo1.lines.add('Erase complete');

     // LCD >
    SendButtonCommand(131);        // LCD "Programming..."
    repeat
      tmp:=Complete;
    until tmp=1;
    // <LCD

    memo1.lines.add('Programming: 0x400 - 0x'+inttohex(63+$400+64*((MaxAddress-$400) div 64),4));
    for i:=0 to (MaxAddress-$400) div 64 do
    begin
      PreSend64($400+64*i);
      Tx64(@MemoryImage[$400+64*i]);
  //    memo1.lines.add('Programming to: '+inttohex($400+64*i+64,4));
    end;
    memo1.lines.add('Programming complete.');
    memo1.lines.add('Verifying...');

    // LCD >
    SendButtonCommand(132);        // LCD "Verifying..."
    repeat
      tmp:=Complete;
    until tmp=1;
    // <LCD

    erra:=0;
    errs:=' OK';
    for j:=0 to (MaxAddress-$400) div 64 +1 do
    begin
      Read64($400+64*j, @ReadImage[$400+64*j]);
      for i:=0 to 63 do
        if ReadImage[$400+64*j+i] <> MemoryImage[$400+64*j+i] then erra:=$400+64*j+i;
    end;
    if erra>0 then
    begin
      memo1.lines.add('Failed verify address: '+inttostr(erra));

      // LCD >
      SendButtonCommand(134);        // LCD "Verify Fail"
      repeat
        tmp:=Complete;
      until tmp=1;
      // <LCD

    end
    else
    begin

      // LCD >
      SendButtonCommand(133);        // LCD "Complete"
      repeat
        tmp:=Complete;
      until tmp=1;
      // <LCD

      memo1.lines.add('Verify complete.');
      Button2.enabled:=true;
 //    Button7.enabled:=true;
      Button11.enabled:=false;
    end;
  end;
end;

(*
procedure TForm1.Button12Click(Sender: TObject);
var i,j: integer;
arr: array[0..63] of byte;
s: string;
begin
  if MaxAddress>$400 then
  begin
    memo1.lines.add('Verifying...');
    for j:=0 to (MaxAddress-$400) div 64 +1 do
    begin
       memo1.lines.add(inttostr(j));
       Read64($400+64*j, @ReadImage[$400+64*j]);
    end;

    for j:=0 to 10 do
    begin
      s:=inttohex($400+j*$10,4)+'  ';
      for i:=0 to 15 do
        s:=s+' '+inttohex(ReadImage[i+$400+j*$10],2);
      memo1.lines.add(s);
    end;
      memo1.lines.add('- - -');
      s:=inttohex(MaxAddress,4)+'  ';
      for i:=0 to 15 do
        s:=s+' '+inttohex(ReadImage[i+MaxAddress],2);
      memo1.lines.add(s);
  end;
end;
*)

procedure TForm1.Button7Click(Sender: TObject);
begin
  SendButtonCommand(99);  // Reset
  Button1Click(Self);
end;

procedure TForm1.Button2Click(Sender: TObject);
var i,tmp,tmp1:integer;
s:string;
begin
  tmp1:=PlayMusic;
  s:='';
  for i:=0 to 15 do
  begin
    tmp:=PlayMusic;
    s:=s+chr(tmp);
  end;
  Memo1.lines.add(s);
  Button2.enabled:=false;
  Button6.enabled:=false;
  Button11.enabled:=false;
  if tmp1=integer('A') then
  begin
    Button7.enabled:=true;
    Button3.enabled:=true;
    Button4.enabled:=true;
    Button5.enabled:=true;
    BitBtn1.enabled:=true;
    BitBtn2.enabled:=true;
    Button8.enabled:=true;
    Button9.enabled:=true;
    Button10.enabled:=true;
    Button12.enabled:=true;
    Button13.enabled:=true;
    Button14.enabled:=true;
    Button15.enabled:=true;
    Button16.enabled:=true;
    Button17.enabled:=true;
    Button18.enabled:=true;
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var i:integer;
begin
  Button3.enabled:=false;
  Button4.enabled:=false;
  Button5.enabled:=false;
  BitBtn1.enabled:=false;
  BitBtn2.enabled:=false;
  Button8.enabled:=false;
  Button9.enabled:=false;
  Button10.enabled:=false;
  Button12.enabled:=false;
  Button13.enabled:=false;
  Button14.enabled:=false;
  Button15.enabled:=false;
  Button16.enabled:=false;
  Button17.enabled:=false;
  Button18.enabled:=false;
  table[1]:=1;
  table[2]:=2;
  table[3]:=3;
  table[4]:=4;
  table[5]:=5;
  table[6]:=7;
  table[7]:=6;
//  if not Button3.enabled then
//    Button2Click(self);
    timed:=false;
    timer1.enabled:=true;
    repeat
      application.processmessages;
    until timed;
    Memo1.lines.add('Updating - please wait...');
    SendButtonCommand(98);
    Timer1.interval:=500;
    timed:=false;
    timer1.enabled:=true;
    repeat
      application.processmessages;
    until timed;
    table[0]:=8;
    SendButtonCommand(table[ComboBox1.ItemIndex]);
    table[0]:=9;
    SendButtonCommand(table[ComboBox2.ItemIndex]);
    table[0]:=10;
    SendButtonCommand(table[ComboBox3.ItemIndex]);
    table[0]:=11;
    SendButtonCommand(table[ComboBox4.ItemIndex]);
    table[0]:=12;
    SendButtonCommand(table[ComboBox5.ItemIndex]);
    table[0]:=13;
    SendButtonCommand(table[ComboBox6.ItemIndex]);
    table[0]:=14;
    SendButtonCommand(table[ComboBox7.ItemIndex]);     
    Memo1.lines.add('Update complete.');
    Button10.enabled:=true;
    Timer1.interval:=3000;
    Button3.enabled:=true;
    Button4.enabled:=true;
    Button5.enabled:=true;
    Button7.enabled:=true;
    BitBtn1.enabled:=true;
    BitBtn2.enabled:=true;
    Button8.enabled:=true;
    Button9.enabled:=true;
    Button10.enabled:=true;
    Button12.enabled:=true;
    Button13.enabled:=true;
    Button14.enabled:=true;
    Button15.enabled:=true;
    Button16.enabled:=true;
    Button17.enabled:=true;
    Button18.enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.enabled:=false;
  timed:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ComboBox1.ItemIndex:=0;
 ComboBox2.ItemIndex:=0;
 ComboBox3.ItemIndex:=0;
 ComboBox4.ItemIndex:=0;
 ComboBox5.ItemIndex:=0;
 ComboBox6.ItemIndex:=0;
 ComboBox7.ItemIndex:=0;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  SendButtonCommand(8);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  SendButtonCommand(9);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  SendButtonCommand(10);
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  SendButtonCommand(11);
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  SendButtonCommand(12);
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  SendButtonCommand(13);
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  SendButtonCommand(14);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  SendButtonCommand(4);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  SendButtonCommand(5);
end;

end.
